<cfsetting enablecfoutputonly="true" />

<!--- Define page variables. --->
<cfparam
	name="FORM.action"
	type="string"
	default="" />

<cfparam
	name="FORM.value"
	type="string"
	default="" />

<cfparam
	name="VARIABLES.qResults"
	type="query"
	default="#queryNew('')#" />


<cfset FORM.action = trim( FORM.action ) />
<cfset FORM.value = trim( FORM.value ) />


<!--- Pick an action to perform. --->
<cfswitch expression="#FORM.action#">


	<cfcase value="subscriber-add">
		
		<!--- BEGIN: Something was passed in as an email. --->
		<cfif len( FORM.value )>
			
			<!--- Only proceed if the value is a valid email address. --->
			<cfif isValid( "email", FORM.value )>
			
				<!--- See if the email is already registered. --->
				<cfquery name="VARIABLES.qResults" datasource="#APPLICATION.sSettings.datasource#">
					SELECT email
					FROM subscriber
					WHERE email = <cfqueryparam cfsqltype="cf_sql_varchar" value="#FORM.value#" />
				</cfquery>
				
				<!--- Email is already registered. --->
				<cfif variables.qResults.recordCount>
					
					<cfoutput>
						<span class="subscriber-error">
							This email address is already registered.
						</span>
					</cfoutput>
					
				<!--- This is a new email. --->
				<cfelse>
				
					<!--- Save it in the database. --->
					<cfquery datasource="#APPLICATION.sSettings.datasource#">
						INSERT INTO subscriber
						(
							email
							,date_subscribed
						)
						VALUES
						(
							<cfqueryparam cfsqltype="cf_sql_varchar" value="#FORM.value#" />
							,<cfqueryparam cfsqltype="cf_sql_timestamp" value="#now()#" />
						)
					</cfquery>
					
					<!--- Message to be returned to the user. --->
					<cfoutput>
						Thank you!<br />
						You've been added to our newsletter.
					</cfoutput>
					
				</cfif>
			
			<!--- Not a valid email address. --->
			<cfelse>
			
				<cfoutput>
					<span class="subscriber-error">
						Sorry!<br />
						This is not a valid Email address.
					</span>
				</cfoutput>
			
			</cfif>
			
		</cfif>
		<!--- END: Something was passed in as an email. --->
	
	</cfcase>


</cfswitch>


<cfsetting enablecfoutputonly="false" />